/*pub use self::join::join;
pub use self::run::run;
pub use self::traits::{Server, ServerJsonRequest, ServerRef, ServerRefRq};*/

use crate::{raw_server::RawServerRef, JsonValue};
use futures::prelude::*;
use std::{io, pin::Pin};

/*mod join;
mod run;
mod traits;*/

/// Wraps around a "raw server".
pub struct Server<R> {
    raw: R,
}

impl<R> Server<R>
where
    for<'r> &'r R: RawServerRef<'r>
{
    /// Returns a `Future` resolving to the next request that this server generates.
    pub async fn next_request<'a>(&'a self) -> Result<ServerRq<'a, R>, ()> {
        // This piece of code is where we analyze requests.
        let payload = self.raw.next_payload().await?;
        panic!()
    }
}

/// Request generated by a `Server`.
///
/// > **Note**: Holds a borrow of the `Server`. Therefore, must be dropped before the `Server` can
/// >           be dropped.
pub struct ServerRq<'a, R> {
    server: &'a Server<R>,
}

impl<'a, R> ServerRq<'a, R>
where
    for<'r> &'r R: RawServerRef<'r>
{
    /// Returns the method of this request.
    pub fn method(&self) -> &str {
        "test"
    }

    /// Returns the parameters of the request.
    pub fn params(&self) -> &JsonValue {
        &JsonValue::Null
    }

    /// Send back a response.
    pub async fn respond(self, response: JsonValue) -> Result<(), io::Error> {
        unimplemented!()
    }

    // TODO: pub async fn respond_subscribe() {}
}
